#|

Various constants or parameters used around the web interface

|#

(in-package #:cl-deck-builder2.web)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; builder.lisp

(defparameter +main-deck-card-limit+ 60)

(defparameter +extra-deck-card-limit+ 15)

(defparameter +search-params+
  '(:ATTRIBUTE ("DARK" "DIVINE" "EARTH" "FIRE" "LIGHT" "WATER" "WIND")
    :TYPE
    ("Effect Monster" "Flip Effect Monster" "Fusion Monster"
     "Gemini Monster" "Link Monster" "Normal Monster"
     "Normal Tuner Monster" "Pendulum Effect Fusion Monster"
     "Pendulum Effect Monster" "Pendulum Effect Ritual Monster"
     "Pendulum Flip Effect Monster" "Pendulum Normal Monster"
     "Pendulum Tuner Effect Monster" "Ritual Effect Monster"
     "Ritual Monster" "Skill Card" "Spell Card" "Spirit Monster"
     "Synchro Monster" "Synchro Pendulum Effect Monster"
     "Synchro Tuner Monster" "Token" "Toon Monster" "Trap Card"
     "Tuner Monster" "Union Effect Monster" "XYZ Monster"
     "XYZ Pendulum Effect Monster")
    :RACE
    ("Abidos the Third" "Adrian Gecko" "Alexis Rhodes" "Amnael" "Andrew"
     "Aqua" "Arkana" "Aster Phoenix" "Axel Brodie" "Bastion Misaw" "Beast"
     "Beast-Warrior" "Bonz" "Camula" "Chazz Princet" "Christine" "Chumley Huffi"
     "Continuous" "Counter" "Creator-God" "Cyberse" "David"
     "Dinosaur" "Divine-Beast" "Don Zaloog" "Dr. Vellian C" "Dragon" "Emma"
     "Equip" "Espa Roba" "Fairy" "Field" "Fiend" "Fish" "Illusionist"
     "Insect" "Ishizu" "Ishizu Ishtar" "Jaden Yuki" "Jesse Anderso" "Joey"
     "Joey Wheeler" "Kagemaru" "Kaiba" "Keith" "Lumis and Umb" "Lumis Umbra"
     "Machine" "Mai" "Mai Valentine" "Mako" "Nightshroud" "Normal"
     "Odion" "Paradox Broth" "Pegasus" "Plant" "Psychic" "Pyro"
     "Quick-Play" "Reptile" "Rex" "Ritual" "Rock" "Sea Serpent" "Seto Kaiba"
     "Spellcaster" "Syrus Truesda" "Tania" "Tea Gardner" "The Supreme K"
     "Thelonious Vi" "Thunder" "Titan" "Tyranno Hassl" "Warrior"
     "Weevil" "Winged Beast" "Wyrm" "Yami Bakura" "Yami Marik" "Yami Yugi"
     "Yubel" "Yugi" "Zane Truesdal" "Zombie")
    :FRAME-TYPE
    ("effect" "effect_pendulum" "fusion" "fusion_pendulum" "link"
     "normal" "normal_pendulum" "ritual" "ritual_pendulum" "skill" "spell"
     "synchro" "synchro_pendulum" "token" "trap" "xyz" "xyz_pendulum")
    :ARCHETYPE
    ("\"C\"" "-Eyes Dragon" "@Ignister" "A.I." "ABC" "Abyss Actor" "Abyss Script"
     "Adamancipator" "Advanced Crystal Beast" "Adventurer Token" "Aesir" "Aether"
     "Albaz Dragon" "Alien" "Alligator" "Allure Queen" "Ally of Justice"
     "Altergeist" "Amazement" "Amazoness" "Amorphage" "Ancient Gear"
     "Ancient Treasure" "Ancient Warriors" "Anti" "Apoqliphort" "Appliancer"
     "Aquaactress" "Aquamirror" "Arcana Force" "Archfiend" "Armed Dragon" "Aroma"
     "Artifact" "Assault Mode" "Atlantean" "Attraction" "Attribute Summoner"
     "B.E.S." "Bamboo Sword" "Barbaros" "Barian's" "Batteryman" "Battleguard"
     "Battlewasp" "Battlin' Boxer" "Battlin' Boxing" "Beetrooper"
     "Black Luster Soldier" "Blackwing" "Blaze Accelerator" "Blue-Eyes" "Bonding"
     "Book of" "Boot-Up" "Borrel" "Bounzer" "Branded" "Bridge" "Bugroth" "Bujin"
     "Burning Abyss" "Butterfly" "Butterspy" "Bystial" "Cataclysmic"
     "Celtic Guard" "Chaos" "Chaos Phantom" "Charmer" "Chemicritter" "Chronomaly"
     "Chrysalis" "Cipher" "Clear Wing" "Cloudian" "Code Talker" "Codebreaker"
     "Constellar" "Contact" "Cosmic Synchro Monster" "Counter Fairy" "Crusadia"
     "Crystal" "Crystal Beast" "Crystron" "Cubic" "Cupid" "CXyz" "Cyber"
     "Cyber Angel" "Cyber Dragon" "Cyberdark" "Cynet" "D.D." "D/D" "D/D/D"
     "Danger!" "Dark Contract" "Dark Magician" "Dark Scorpion" "Dark World"
     "Darklord" "Deep Sea" "Demise" "Deskbot" "Despia" "Destiny HERO"
     "Destruction Sword" "Dice" "Digital Bug" "Dinomist" "Dinomorphia"
     "Dinowrestler" "Divine Dragon" "Djinn" "Dododo" "Dogmatika" "Doll"
     "Doodle Beast" "Doodlebook" "Doriado" "Dracoslayer" "Dracoverlord"
     "Dragonmaid" "Dragunity" "Dream Mirror" "Drytron" "Dual Avatar" "Duston"
     "Earthbound" "Edge Imp" "Egyptian God" "Eldlich" "Elemental HERO"
     "Elemental Lord" "Elementsaber" "Empowered Warrior" "Endymion" "Evil Eye"
     "Evil HERO" "Evil★Twin" "Evolsaur" "Evoltile" "Evolzar"
     "Exchange of the Spirit" "Exodia" "Exosister" "Eyes Restrict" "F.A." "Fabled"
     "Fairy" "Fairy Tail" "Fire Fist" "Fire Formation" "Fire King" "Firewall"
     "Fishborg" "Flamvell" "Fleur" "Floowandereeze" "Flower Cardian" "Fluffal"
     "Forbidden" "Fortune Fairy" "Fortune Lady" "Fossil" "Frightfur" "Frog"
     "From the Underworld" "Fur Hire" "Fusion" "G Golem" "Gadget" "Gagaga"
     "Gaia Knight" "Gaia The Fierce Knight" "Galaxy" "Galaxy-Eyes" "Gandora"
     "Gate Guardian" "Geargia" "Gem-" "Generaider" "Genex" "Ghostrick" "Ghoti"
     "Gimmick Puppet" "Gishki" "Gizmek" "Glacial Beast" "Gladiator Beast" "Gogogo"
     "Gold Pride" "Golden Castle of Stromberg" "Golden Land" "Gorgonic" "Gouki"
     "Gravekeeper's" "Graydle" "Greed" "Grepher" "Guardian" "Guardragon" "Gunkan"
     "Gusto" "Harpie" "Hazy" "Hellfire" "Herald" "Heraldic" "Heraldry" "HERO"
     "Heroic" "Hi-Speedroid" "Hieratic" "Hole" "Holy Knight"
     "Horus the Black Flame Dragon" "Hyperion" "Ice Barrier" "Icejade" "Igknight"
     "Impcantation" "Infernity" "Infernoble Knight" "Infernoid" "Infestation"
     "Infinitrack" "Invoked" "Inzektor" "Iron Chain" "Jar" "Jester" "Jinzo" "Junk"
     "Jurrac" "Kaiju" "Kairyu-Shin" "Karakuri" "Kashtira" "Knight" "Knightmare"
     "Koa'ki Meiru" "Koala" "Kozmo" "Krawler" "Kuriboh" "Labrynth"
     "Labyrinth Wall" "Lady of Lament" "Laval" "Legendary Knight" "Libromancer"
     "Lightsworn" "Lil-la" "Live☆Twin" "Lswarm" "Lunalight" "Lyrilusc" "Machina"
     "Madolche" "Madoor" "Magical Musket" "Magician" "Magician Girl" "Magikey"
     "Magistus" "Magnet Warrior" "Majespecter" "Majestic" "Maju" "Malefic"
     "Malicevorous" "Man-Eater Bug" "Manadome" "Marincess" "Martial Art Spirit"
     "Mask" "Masked HERO" "Materiactor" "Mathmech" "Mayakashi" "Mayakashi Shiranui"
     "Mecha Phantom Beast" "Megalith" "Mekk-Knight" "Meklord" "Melffy" "Melodious"
     "Mermail" "Metalfoes" "Metaphys" "Mikanko" "Mist Valley" "Mokey Mokey"
     "Monarch" "Morphtronic" "Mystical Beast of the Forest" "Myutant" "Naturia"
     "Nekroz" "Nemeses" "Nemleria" "Nemurelia" "Neo Space" "Neo-Spacian" "Neos"
     "Nephthys" "Nimble" "Ninja" "Ninjitsu Art" "Noble Knight" "Nordic"
     "Nouvellez" "Number" "Numeron" "Odd-Eyes" "Ogdoadic" "Ojama" "Onomat"
     "Orcust" "Overlay" "P.U.N.K." "Paladins of Dragons" "Paleozoic" "Parasite"
     "Parshath" "Pendulum" "Pendulum Dragon" "Penguin" "Performage" "Performapal"
     "Phantasm Spiral" "Phantom Beast" "Phantom Knights" "Photon"
     "Plunder Patroll" "Polymerization" "Possessed" "Potan" "Power Tool"
     "Prank-Kids" "Predaplant" "Prediction Princess" "Priestess" "PSY-Frame"
     "Puppet" "Purrely" "Qli" "Raidraptor" "Rank-Up-Magic" "Recipe" "Red-Eyes"
     "Reptilianne" "Rescue-ACE" "Resonator" "Rikka" "Ritual Beast" "Roid" "Rokket"
     "Roland" "Rose" "Rose Dragon" "Runick" "S-Force" "Sacred Beast"
     "Salamangreat" "Scareclaw" "Scrap" "Scrap-Iron" "Secret Six Samurai"
     "Seven Emperors" "Seventh" "Shaddoll" "Shark" "Shinobird" "Shiranui"
     "Silent Magician" "Silent Swordsman" "Simorgh" "Six Samurai" "Skull Servant"
     "Sky Scourge" "Sky Striker" "Slime" "Solemn" "Solfachord" "Speedroid"
     "Spellbook" "Sphinx" "Spider" "Spirit Message" "Spiritual Art" "Spright"
     "Springans" "SPYRAL" "Star" "Star Seraph" "Stardust" "Starliege"
     "Starry Knight" "Stealth Kragen" "Steelswarm" "Stellarknight" "Subterror"
     "Sunavalon" "Sunseed" "Sunvine" "Super Defense Robot" "Super Quant"
     "Superheavy" "Superheavy Samurai" "Supreme King" "Swordsoul" "Sylvan"
     "Symphonic" "Symphonic Warrior" "Synchro" "Synchron" "T.G." "Tearlaments"
     "Tellarknight" "Tenyi" "The Agent" "The Sanctuary in the Sky" "The Weather"
     "Therion" "Thunder Dragon" "Time Thief" "Timelord" "Tindangle" "Toon" "Train"
     "Transcendrake" "Trap Hole" "Trap Monster" "Traptrix" "Tri-Brigade" "Triamid"
     "Trickstar" "True Draco" "U.A." "Umbral Horror" "Umi" "Unchained" "Ursarctic"
     "Utopia" "Utopic" "Valkyrie" "Vampire" "Vanquish Soul" "Vassal" "Vaylantz"
     "Vendread" "Venom" "Vernusylph" "Virtual World" "Visas" "Vision HERO" "Void"
     "Volcanic" "Vylon" "War Rock" "Watt" "White" "Wicked God" "Wind-Up"
     "Windwitch" "Witchcrafter" "World Chalice" "World Legacy" "Worm" "X-Saber"
     "Xyz" "Yang Zing" "Yosenju" "Yubel" "Zefra" "ZEXAL" "Zoodiac")
    ;; Card Rarity - Not in use at the moment.
    :RARITY
    ("10000 Secret Rare" "Collector's Rare" "Common" "Ghost/Gold Hybrid Rare"
     "Ghost Rare" "Gold Rare" "Gold Secret Rare" "Mosaic Rare" "Parallel Rare"
     "Platinum Rare" "Platinum Secret Rare" "Premium Gold Rare" "Prismatic Secret Rare"
     "Quarter Century Secret Rare" "Rare" "Rare Parallel Rare" "Rush Rare"
     "Secret Pharaoh's Rare" "Secret Rare" "Shatterfoil" "Starfoil Rare"
     "Starlight Rare" "Super Parallel Rare" "Super Rare" "Ultimate Rare"
     "Ultra Parallel Rare" "Ultra Pharaoh's Rare" "Ultra Rare")
    :LIMIT
    ("10" "50" "100" "1000" "2000")))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; search.lisp
