{# doc.0: URL; doc.1: Documentation; doc.2: Methods; doc.3: Params; #}
<pre>
# Project Documentation

This page is automatically generated. Sections are organized like so:

    * METHOD ROUTE PARAMETERS
      DOCSTRING

`METHOD` is usually either `GET` or `POST`, but could be any of the
[HTTP Methods](https://developer.mozilla.org/en-US/docs/Web/HTTP/Methods).

The `ROUTE` is the `URI` endpoint on the application, e.g. `/builder`.

Each `ROUTE` has `PARAMETERS`. Currently, the parameters are parsed by
hand. As the application matures, the parameters will come more into
play.

The `DOCSTRING` is written by me, the developer, and is intended to
provide context on the purpose of the route.

The API follows a basic pattern:

    GET /&lt;base-page&gt;

This will display the main page for the item `&lt;base-page&gt;`.

    DELETE /&lt;base-page&gt;
    PATCH /&lt;base-page&gt;
    POST /&lt;base-page&gt;

If `&lt;base-page&gt;` may have an operation done on it (create,
retrieve, update, delete some values), there will be a matching method
for `DELETE`, `PATCH`, `POST`, etc.

# API Index
{% for doc in docs %}## {{ doc.2 }} {{ doc.0 }} {{ doc.3 }}
{{ doc.1 }}

{% endfor %}
</pre>
