{% if args %}
ARG{% for arg in args %} arg{% endfor %}
{% endif %}
FROM {{ platform }} {{ image }}
RUN {{ apt }} {{ update }}
{% for pkg in packages %}RUN {{ apt }} {{ install }} {{ pkg }}
{% endfor %}
{% if workdir %}WORKDIR {{ workdir }}
{% endif %}
{% for command in pre-commands %}RUN {{ command | safe }}
{% endfor %}
COPY {{ chown }} {{ src }} {{ dst }}
{% for command in post-commands %}RUN {{ command | safe }}
{% endfor %}
{% if expose %}EXPOSE{% for arg in expose %} arg{% endfor %}
{% endif %}
{% if user %}USER user
{% endif %}
CMD {{ cmd | safe }}
